import java.net.URL;
import java.sql.*;


/*
 * How searches would be done if mSQL supported transactions
 * and prepared SQL statements
 */


class PimSearch2
{
    public static void main (String args[])
    {
        try {
            // connect to mSQL database pim
            Class.forName ("com.imaginary.sql.msql.MsqlDriver");
            String url = "jdbc:msql://localhost:1114/pim";
            Connection con = DriverManager.getConnection (url, "borg", "");

            // The default behaviour for JDBC is to commit every SQL
            // statement executed. We want to comit ourselves
            con.setAutoCommit (false);

            // prepare the statement
            // the question marks are placeholers for the actual parameters
            PreparedStatement stmt = con.prepareStatement (
                "SELECT first_name, last_name, title, e_mail FROM addr_book "
                + "WHERE company = ?");

            // bind parameters to the statement
            stmt.setString (1, args[0]);

            // execute the query
            ResultSet res = stmt.executeQuery ();

            // list the returned rows
            while (res.next ()) {
                System.out.println ("");
                System.out.println ("Name:\t" + res.getString (1) + " "
                    + res.getString (2));
                System.out.println ("Title:\t" + res.getString (3));
                System.out.println ("E-mail:\t" + res.getString (4));
            }

            // commit writes to the database
            con.commit ();

            // clean-up
            stmt.close ();
            con.close ();
        }
        catch (Exception e) {
            // do not call rollback() on database errors, but
            // just if you detect application errors.
            // rollback() will throw a SQLException.
            //con.rollback ();
            System.out.println (e.getMessage ());
            e.printStackTrace ();
        }
    }
}

