import java.net.URL;
import java.sql.*;


/*
 * How updates would be done if mSQL supported transactions
 * and prepared SQL statements
 */


class PimUpdNull2
{
    public static void main (String args[])
    {
        try {
            // connect to some database
            Class.forName ("com.imaginary.sql.msql.MsqlDriver");
            String url = "jdbc:msql://localhost:1114/pim";
            Connection con = DriverManager.getConnection (url, "borg", "");

            // The default behaviour for JDBC is to commit every SQL
            // statement executed. We want to comit ourselves
            con.setAutoCommit (false);

            // prepare the statement
            // the question marks are placeholers for the actual parameters
            PreparedStatement stmt = con.prepareStatement (
                "UPDATE addr_book SET company = ?"
                + "WHERE company = ?");

            // bind parameters to the statement
            stmt.setString (1, "freelancer");
            stmt.setNull (2, java.sql.Types.CHAR);

            // execute the update
            int numRows = stmt.executeUpdate ();


            // commit writes to the database
            con.commit ();

            // show how many rows where affected
            System.out.println (numRows + " rows where updated.\n");

            // clean-up
            stmt.close ();
            con.close ();
        }
        catch (Exception e) {
            // do not call rollback() on database errors, but
            // just if you detect application errors.
            // rollback() will throw a SQLException.
            //con.rollback ();
            System.out.println (e.getMessage ());
            e.printStackTrace ();
        }
    }
}

